#ifndef _SLACGEN_H_
#define _SLACGEN_H_

#include <stdio.h>
#include <stdlib.h>

#include "ansi_colors.h"

#define MAX(a,b) ( (a) > (b) ? (a) : (b) )

#define CHECKALLOC(a) {  \
  if ( (a)==NULL ){ \
    fprintf(stderr,"Allocation failure - file %s line %d\n",__FILE__,__LINE__); \
    exit(EXIT_FAILURE); \
  } \
}

// C99 introduced __func__, and GCC has provided __FUNCTION__
#define MESSAGEFAILURE( test, mess ) { \
  if ( (test) ){ \
    fprintf(stderr,"%s %s :%s ligne : %d",__func__,mess,__FILE__,__LINE__);\
    exit(EXIT_FAILURE); \
  }\
}

// C99 introduced __func__, and GCC has provided __FUNCTION__
#define MESSAGEWARNING( mess ) { \
  fprintf(stderr,"%s :%s ligne : %d -> %s",__func__,__FILE__,__LINE__,mess);\
}

#ifdef DEBUG
#define PRINTMEMORYDEBUG(funcname,type,addr) { \
  printf(ANSI_COLOR_GREEN"%s: %s<"ANSI_COLOR_BLUE"%p"ANSI_COLOR_GREEN">\n" ANSI_COLOR_RESET ,funcname,type,addr);\
}
#else
#define PRINTMEMORYDEBUG(funcname,type,addr) {}
#endif

#endif
