#include<stdlib.h>
#include<stdio.h>
#include "Vector.h"
#include "Matrix.h"
#include "SLAC.h"


int main(void){
  //***********************************************************SolverUpper***********************************************************//
printf("//***************************************SolveUpper***************************************//\n" );
  Matrix M = AllocMatrix_out(2,2);
  M.val[0][0]=1; M.val[0][1]=2;
  M.val[1][0]=0;M.val[1][1]=1;

  Matrix L = AllocMatrix_out(2,2);
  L.val[0][0]=1; L.val[0][1]=0;
  L.val[1][0]=2; L.val[1][1]=1;


  Vector x_out = AllocVector_out(2);
  Vector x_upper; //AllocVector(2,&x);
  Vector b = AllocVector_out(2);
  b.val[0]=3; b.val[1] = 1;

  x_out = SolveUpper_out(M,b);
  SolveUpper(M,b,&x_upper);

  for(int i = 0; i < M.rows; i++){
    printf("x_out[%d] = %lf\n",i, x_out.val[i] );
    printf("x[%d] = %lf\n",i, x_upper.val[i] );
  }

  Vector2zero(x_out);


  printf("//***************************************SolveUpper***************************************//\n" );
  Vector x_lower;
  x_out = SolveLower_out(L,b);
  SolveLower(L,b,&x_lower);

  for(int i = 0; i < M.rows; i++){
    printf("x_out[%d] = %lf\n",i, x_out.val[i] );
    printf("x[%d] = %lf\n",i, x_lower.val[i] );
  }

  FREEVector(&x_upper);
  FREEVector(&x_lower);
  FREEVector(&x_out);
  FREEMatrix(&M);
  FREEMatrix(&L);


  //***********************************************************MatVecProd***********************************************************//

printf("//***************************************MatVecProd***************************************//\n" );
  Matrix Q = AllocMatrix_out(2,2);
  Q.val[0][0] = 1; Q.val[0][1] = 1;
  Q.val[1][0] = 1; Q.val[1][1] = 1;
  Vector U = AllocVector_out(2);
  U.val[0] = 2;
  U.val[1] = 3;

  Vector V; //= AllocVector_out(2);
  Vector V_out = AllocVector_out(2);

  MatVecProd(Q,U,&V);
  V_out = MatVecProd_out(Q,U);


  for(int i = 0; i < V.dim; i++){
    printf("V[%d] = %lf\n",i,V.val[i] );
  }
  for(int i = 0; i < V_out.dim; i++){
    printf("V_out[%d] = %lf\n",i,V_out.val[i] );
  }


    FREEVector(&U);
    FREEVector(&V);
    FREEVector(&V_out);
    FREEMatrix(&Q);


    //***********************************************************Cholesky***********************************************************//
    printf("//***************************************Cholesky***************************************//\n" );

    printf("\n\n");
    int N_gr2 = 2 ;
    Matrix A = AllocRandSPDMatrix_out(N_gr2);
    PrintMatrix(A," A ",N_gr2,N_gr2);
    Matrix B; //= AllocMatrix_out(N_gr2,N_gr2);
    Cholesky(A,&B);
    PrintMatrix(B," B ",N_gr2,N_gr2);
    Matrix B_transp = AllocMatrix_out(N_gr2,N_gr2);
    B_transp = TransposeMatrix_out(B) ;
    PrintMatrix(MatrixProd_out(B,B_transp)," Produit (vérification) ",N_gr2,N_gr2);
    B = Cholesky_out(A);
    PrintMatrix(B," B (out) ",N_gr2,N_gr2);

      //***********************************************************SolveCholesky***********************************************************//
printf("//***************************************SolveCholesky***************************************//\n" );
      Vector b_gr2 = AllocRandVector_out(N_gr2,0,1) ;
      PrintVector2(b_gr2, " Vector b ") ;
      Vector x_gr2 = AllocVector_out(N_gr2);
      SolveCholesky(B,b_gr2,&x_gr2);
      PrintVector2(x_gr2," Solution ");
      x_gr2 = SolveCholesky_out(B,b_gr2);
      PrintVector2(x_gr2," Solution avec out ");


      FREEMatrix(&A);
      FREEMatrix(&B);
      FREEMatrix(&B_transp);
      FREEVector(&x_gr2);
      FREEVector(&b_gr2);

      printf("\n\n");

      //***********************************************************Gauss***********************************************************//
printf("//***************************************Gauss***************************************//\n" );
      AllocMatrix(3, 3, &A);
      // A={{2,-3,1},{1,1,1},{3,-1,1}};
      A.val[0][0]=2;A.val[0][1]=-3;A.val[0][2]=1;
      A.val[1][0]=1;A.val[1][1]=1;A.val[1][2]=1;
      A.val[2][0]=3;A.val[2][1]=-1;A.val[2][2]=1;

      Vector c;
      Vector px;

      AllocVector(3,&c);

      AllocVector(3,&px);

      // b[3]={-8,3,-1};
      c.val[0]=-8;
      c.val[1]=3;
      c.val[2]=-1;

      //SolveGauss(A,c,&px);
      //SolveGauss_in(A,c);
      px=SolveGauss_out(A,c);
      for (int i=0;i<3;i++){
          printf("x[%d] = %2lf \n",i,px.val[i]);
      }


      FREEMatrix(&A);
      FREEVector(&c);
      FREEVector(&px);
      //***********************************************************LU***********************************************************//
      printf("//***************************************LU***************************************//\n" );

      Matrix Charlie,Lower,Upper,T;
      unsigned int N=5;

      AllocRandMatrix(N,N,-M_PI,M_PI,&Charlie);
      AllocMatrix( N, N, &T);/*La matrice T est la matrice qui contiendra A-L*U */
      PrintMatrix(Charlie,"Charlie",N,N);/* affichage de la matrice A*/
      LU( Charlie, &Lower, &Upper);
      PrintMatrix(Lower,"Lower",N,N); /* affichage de la matrice L */
      PrintMatrix(Upper,"Upper",N,N); /* affichage de la matrice U */
      MatrixProd(Lower,Upper,&T);
      MatrixSumLocRight (1,Charlie,-1,T); /* Calcul de A-L*U */
      PrintMatrix(T,"T",N,N);





      FREEMatrix(&Charlie);
      FREEMatrix(&Lower);
      FREEMatrix(&Upper);
      FREEMatrix(&T);




  return EXIT_SUCCESS;
}
